Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkPicker Class Reference

`#include <vtkPicker.h>`

Inheritance diagram for vtkPicker:

[legend]
Collaboration diagram for vtkPicker:

[legend]
List of all members.

## Detailed Description

superclass for 3D geometric pickers (uses ray cast)

Date:
  2002/08/26 02:31:16

Revision:
  1.48

vtkPicker is used to select instances of vtkProp3D by shooting a ray into a graphics window and intersecting with the actor's bounding box. The ray is defined from a point defined in window (or pixel) coordinates, and a point located from the camera's position.

vtkPicker may return more than one vtkProp3D, since more than one bounding box may be intersected. vtkPicker returns the list of props that were hit, the pick coordinates in world and untransformed mapper space, and the prop (vtkProp3D) and mapper that are "closest" to the camera. The closest prop is the one whose center point (i.e., center of bounding box) projected on the ray is closest to the camera.

See also:
  vtkPicker is used for quick geometric picking. If you desire to pick points or cells, use the subclass vtkPointPicker or vtkCellPicker, respectively. Or you may use hardware picking to pick any type of vtkProp
  - see vtkPropPicker or vtkWorldPointPicker.

Events:
  vtkCommand::EndPickEvent vtkCommand::StartPickEvent vtkCommand::PickEvent

Created by:
  - Schroeder, Will

CVS contributions (if > 5%):
  - Schroeder, Will (70%)
  - Martin, Ken (9%)
  - Lorensen, Bill (6%)

CVS logs (CVSweb):
  - .`h` (`/Rendering/vtkPicker.h)`
  - .`cxx` (`/Rendering/vtkPicker.cxx)`

Definition at line 68 of file vtkPicker.h.

## Public Types
typedef vtkAbstractPropPicker | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
vtkProp3DCollection * | GetProp3Ds ()
vtkActorCollection * | GetActors ()
vtkPoints * | GetPickedPositions ()
virtual void | SetTolerance (float)
virtual float | GetTolerance ()
virtual float * | GetMapperPosition ()
virtual void | GetMapperPosition (float data[3])
virtual vtkAbstractMapper3D * | GetMapper ()
virtual vtkDataSet * | GetDataSet ()
virtual int | Pick (float selectionX, float selectionY, float selectionZ, vtkRenderer *renderer)
int | Pick (float selectionPt[3], vtkRenderer *ren)
## Static Public Methods
vtkPicker * | New ()
int | IsTypeOf (const char *type)
vtkPicker * | SafeDownCast (vtkObject *o)
## Protected Methods
| vtkPicker ()
| ~vtkPicker ()
void | MarkPicked (vtkAssemblyPath *path, vtkProp3D *p, vtkAbstractMapper3D *m, float tMin, float mapperPos[3])
virtual float | IntersectWithLine (float p1[3], float p2[3], float tol, vtkAssemblyPath *path, vtkProp3D *p, vtkAbstractMapper3D *m)
virtual void | Initialize ()
## Protected Attributes
float | Tolerance
float | MapperPosition [3]
vtkAbstractMapper3D * | Mapper
vtkDataSet * | DataSet
float | GlobalTMin
vtkTransform * | Transform
vtkActorCollection * | Actors
vtkProp3DCollection * | Prop3Ds
vtkPoints * | PickedPositions

## Member Typedef Documentation

typedef vtkAbstractPropPicker vtkPicker::Superclass

| Reimplemented from vtkAbstractPropPicker. Reimplemented in vtkCellPicker, and vtkPointPicker. Definition at line 72 of file vtkPicker.h.

## Constructor & Destructor Documentation

vtkPicker::vtkPicker | ( |  | ) | `[protected]`

vtkPicker::~vtkPicker | ( |  | ) | `[protected]`

## Member Function Documentation

vtkPicker* vtkPicker::New | ( |  | ) | `[static]`

| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. Reimplemented from vtkObject. Reimplemented in vtkCellPicker, and vtkPointPicker.

virtual const char* vtkPicker::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkAbstractPropPicker. Reimplemented in vtkCellPicker, and vtkPointPicker.

int vtkPicker::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkAbstractPropPicker. Reimplemented in vtkCellPicker, and vtkPointPicker.

virtual int vtkPicker::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkAbstractPropPicker. Reimplemented in vtkCellPicker, and vtkPointPicker.

vtkPicker* vtkPicker::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkAbstractPropPicker. Reimplemented in vtkCellPicker, and vtkPointPicker.

void vtkPicker::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkAbstractPropPicker. Reimplemented in vtkCellPicker, and vtkPointPicker.

virtual void vtkPicker::SetTolerance | ( | float |  | ) | `[virtual]`

| Specify tolerance for performing pick operation. Tolerance is specified as fraction of rendering window size. (Rendering window size is measured across diagonal.)

virtual float vtkPicker::GetTolerance | ( |  | ) | `[virtual]`

| Specify tolerance for performing pick operation. Tolerance is specified as fraction of rendering window size. (Rendering window size is measured across diagonal.)

virtual float* vtkPicker::GetMapperPosition | ( |  | ) | `[virtual]`

| Return position in mapper (i.e., non-transformed) coordinates of pick point.

virtual void vtkPicker::GetMapperPosition | ( | float | data[3] | ) | `[virtual]`

| Return position in mapper (i.e., non-transformed) coordinates of pick point.

virtual vtkAbstractMapper3D* vtkPicker::GetMapper | ( |  | ) | `[virtual]`

| Return mapper that was picked (if any).

virtual vtkDataSet* vtkPicker::GetDataSet | ( |  | ) | `[virtual]`

| Get a pointer to the dataset that was picked (if any). If nothing was picked then NULL is returned.

vtkProp3DCollection* vtkPicker::GetProp3Ds | ( |  | ) | `[inline]`

| Return a collection of all the prop 3D's that were intersected by the pick ray. This collection is not sorted. Definition at line 102 of file vtkPicker.h.

vtkActorCollection* vtkPicker::GetActors | ( |  | ) |

| Return a collection of all the actors that were intersected. This collection is not sorted. (This is a convenience method to maintain backward compatibility.)

vtkPoints* vtkPicker::GetPickedPositions | ( |  | ) | `[inline]`

| Return a list of the points the the actors returned by GetActors were intersected at. The order of this list will match the order of GetActors. Definition at line 112 of file vtkPicker.h.

virtual int vtkPicker::Pick | ( | float | selectionX,
|  | float | selectionY,
|  | float | selectionZ,
|  | vtkRenderer * | renderer
| ) | `[virtual]`

| Perform pick operation with selection point provided. Normally the first two values for the selection point are x-y pixel coordinate, and the third value is =0. Return non-zero if something was successfully picked. Implements vtkAbstractPicker.

int vtkPicker::Pick | ( | float | selectionPt[3],
|  | vtkRenderer * | ren
| ) | `[inline]`

| Perform pick operation with selection point provided. Normally the first two values for the selection point are x-y pixel coordinate, and the third value is =0. Return non-zero if something was successfully picked. Reimplemented from vtkAbstractPicker. Definition at line 128 of file vtkPicker.h. References vtkAbstractPicker::Pick().

void vtkPicker::MarkPicked | ( | vtkAssemblyPath * | path,
|  | vtkProp3D * | p,
|  | vtkAbstractMapper3D * | m,
|  | float | tMin,
|  | float | mapperPos[3]
| ) | `[protected]`

virtual float vtkPicker::IntersectWithLine | ( | float | p1[3],
|  | float | p2[3],
|  | float | tol,
|  | vtkAssemblyPath * | path,
|  | vtkProp3D * | p,
|  | vtkAbstractMapper3D * | m
| ) | `[protected, virtual]`

| Reimplemented in vtkCellPicker, and vtkPointPicker.

virtual void vtkPicker::Initialize | ( |  | ) | `[protected, virtual]`

| Reimplemented from vtkAbstractPropPicker. Reimplemented in vtkCellPicker, and vtkPointPicker.

## Member Data Documentation

float vtkPicker::Tolerance`[protected]`

| Definition at line 143 of file vtkPicker.h.

float vtkPicker::MapperPosition[3]`[protected]`

| Definition at line 144 of file vtkPicker.h.

vtkAbstractMapper3D* vtkPicker::Mapper`[protected]`

| Definition at line 146 of file vtkPicker.h.

vtkDataSet* vtkPicker::DataSet`[protected]`

| Definition at line 147 of file vtkPicker.h.

float vtkPicker::GlobalTMin`[protected]`

| Definition at line 149 of file vtkPicker.h.

vtkTransform* vtkPicker::Transform`[protected]`

| Definition at line 150 of file vtkPicker.h.

vtkActorCollection* vtkPicker::Actors`[protected]`

| Definition at line 151 of file vtkPicker.h.

vtkProp3DCollection* vtkPicker::Prop3Ds`[protected]`

| Definition at line 152 of file vtkPicker.h.

vtkPoints* vtkPicker::PickedPositions`[protected]`

| Definition at line 153 of file vtkPicker.h.

The documentation for this class was generated from the following file:

- Rendering/vtkPicker.h